%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% SPDX-License-Identifier: LGPL-3.0-or-later
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('round'), 1)
assert_isequal(nargout('round'), 1)
%=============================================================================
A = [2.3 3.8 5.5 -2.3 -3.8 -5.5];
REF = [2     4     6    -2    -4    -6];
R = round(A);
assert_isequal(R, REF);
%=============================================================================
A = single([2.3 3.8 5.5 -2.3 -3.8 -5.5]);
R = round(A);
REF = single([2     4     6    -2    -4    -6]);
assert_isequal(R, REF);
%=============================================================================
A = [2.3 3.8 5.5 -2.3 -3.8 -5.5];
REF = [2     4     6    -2    -4    -6];
R = round(sparse(A));
REF = sparse(REF);
assert_isequal(R, REF);
%=============================================================================
A = complex([2.3 3.8 5.5 -2.3 -3.8 -5.5], [2.3 3.8 5.5 -2.3 -3.8 -5.5] * 2);
R = round(A);
REF = [2.0000+5.0000i, 4.0000+8.0000i, 6.0000+11.0000i, -2.0000-5.0000i, -4.0000-8.0000i, -6.0000-11.0000i];
assert_isequal(R, REF);
%=============================================================================
A = round(int8(3));
R = class(A);
assert_isequal(R, 'int8');
%=============================================================================
assert_isequal(round(NaN), NaN);
assert_isequal(round(Inf), Inf);
assert_isequal(round(-Inf), -Inf);
assert_isequal(round(zeros(0, 3)), zeros(0, 3));
%=============================================================================
