//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#pragma once
//=============================================================================
#include "ArrayOf.hpp"
#include "GOProperty.hpp"
#include "ClassName.hpp"
//=============================================================================
namespace Nelson {
//=============================================================================
class GOArrayOfProperty : public GOProperty
{
protected:
    ArrayOf m_data;

public:
    //=============================================================================
    GOArrayOfProperty() = default;
    //=============================================================================
    ~GOArrayOfProperty() override = default;
    //=============================================================================
    ArrayOf
    get() override;
    //=============================================================================
    void set(ArrayOf /*unused*/) override;
    //=============================================================================
    std::string
    print(const std::string& propertyName) override
    {
        std::string v;
        if (m_data.isNumeric() && m_data.isEmpty(true)) {
            v = "[]";
        } else {
            Dimensions dims = m_data.getDimensions();
            v = "[" + dims.toString() + " " + ClassName(m_data) + "]";
        }
        return "\t" + propertyName + ":\t" + v;
    }
    //=============================================================================
    ArrayOf
    data()
    {
        return m_data;
    }
    //=============================================================================
    void
    value(const ArrayOf& m)
    {
        m_data = m;
    }
    //=============================================================================
};
//=============================================================================
} // namespace Nelson
//=============================================================================
