//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#pragma once
//=============================================================================
#include "ArrayOf.hpp"
#include "GOProperty.hpp"
#include "Error.hpp"
//=============================================================================
namespace Nelson {
//=============================================================================
class GOColorProperty : public GOProperty
{
protected:
    double R;
    double G;
    double B;

public:
    //=============================================================================
    GOColorProperty() = default;
    //=============================================================================
    ~GOColorProperty() override = default;
    //=============================================================================
    ArrayOf
    get() override;
    //=============================================================================
    void set(ArrayOf /*value*/) override;
    //=============================================================================
    std::vector<double>
    asVector()
    {
        std::vector<double> rgb;
        rgb.reserve(3);
        rgb.push_back(R);
        rgb.push_back(G);
        rgb.push_back(B);
        return rgb;
    }
    //=============================================================================
    std::vector<double>
    data()
    {
        return asVector();
    }
    //=============================================================================
    std::string
    print(const std::string& propertyName) override;
    //=============================================================================
    void
    value(double r, double g, double b)
    {
        R = r;
        G = g;
        B = b;
    }
    //=============================================================================
};
//=============================================================================
} // namespace Nelson
//=============================================================================
