//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#pragma once
//=============================================================================
#include "nlsMex_exports.h"
#include "MxTypes.h"
//=============================================================================
#ifdef __cplusplus
extern "C"
{
#endif
    //=============================================================================
    NLSMEX_IMPEXP
    void*
    mxMalloc(mwSize n);
    //=============================================================================
    NLSMEX_IMPEXP
    void*
    mxCalloc(mwSize n, mwSize size);
    //=============================================================================
    NLSMEX_IMPEXP
    void*
    mxRealloc(void* ptr, mwSize size);
    //=============================================================================
    NLSMEX_IMPEXP void
    mxFree(void* ptr);
    //=============================================================================
    NLSMEX_IMPEXP bool
    mxIsRegisteredPointer(void* ptr);
    //=============================================================================
    NLSMEX_IMPEXP
    void
    mxDestroyArray(mxArray* pm);
    //=============================================================================
    NLSMEX_IMPEXP
    void
    mexMakeArrayPersistent(mxArray* pm);
    //=============================================================================
    NLSMEX_IMPEXP
    void
    mexMakeMemoryPersistent(void* ptr);
    //=============================================================================
    NLSMEX_IMPEXP void
    mexFreeAllRegisteredPointer();
    //=============================================================================
    NLSMEX_IMPEXP
    mxArray*
    mxDuplicateArray(const mxArray* in);
    //=============================================================================
#ifdef __cplusplus
}
#endif
//=============================================================================
