%=============================================================================
% Copyright (c) 2017 Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% SPDX-License-Identifier: LGPL-3.0-or-later
% LICENCE_BLOCK_END
%=============================================================================
% <-- Issue URL -->
% https://github.com/Nelson-numerical-software/nelson/issues/509
% <-- Short Description -->
% add horzcat vertcat generic support for class object
%=============================================================================
A = weboptions();
R = [A, A];
assert_isequal(size(struct(R)), [1 2])
assert_isequal(class(R), 'weboptions')
%=============================================================================
R = [A; A];
assert_isequal(size(struct(R)), [2 1])
assert_isequal(class(R), 'weboptions')
%=============================================================================


R = [1 2]:3;
REF = [1 2 3];
assert_isequal(R, REF);
assert_isequal(lastwarn(), _('Array used as scalar.'));
%=============================================================================
R = ([1 : 2]):3;
REF = [1 2 3];
assert_isequal(R, REF);
%=============================================================================
R = [1,2; 3, 4]:3;
REF = [1 2 3];
assert_isequal(R, REF);
%=============================================================================
R = [2:4]:[3:5]:[6:7];
REF = [2 5];
assert_isequal(R, REF);
%=============================================================================
R = []:3;
REF = zeros(1, 0);
assert_isequal(R, REF);
%=============================================================================
R = 1:2:[];
REF = zeros(1, 0);
assert_isequal(R, REF);
%=============================================================================
R = 1:[]:4;
REF = zeros(1, 0);
assert_isequal(R, REF);
%=============================================================================
R = 1:2:zeros(3, 0);
REF = zeros(1, 0);
assert_isequal(R, REF);
%=============================================================================
