%=============================================================================
% Copyright (c) 2017 Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% SPDX-License-Identifier: LGPL-3.0-or-later
% LICENCE_BLOCK_END
%=============================================================================
% <-- Issue URL -->
% https://github.com/Nelson-numerical-software/nelson/issues/587
% <-- Short Description -->
% implicit cast to string array for horzcat and vertcat operators
%=============================================================================
A = {'a'; 'b';'c'};
B = ["d"; "e"; "f"];
%=============================================================================
R = [B; A];
REF = ["d";"e";"f";"a";"b";"c"];
assert_isequal(R, REF);
%=============================================================================
R = [A; B];
REF = ["a";"b";"c";"d";"e";"f"];
assert_isequal(R, REF);
%=============================================================================
A = {'a'; 2;'c'};
B = ["d"; "e"; "f"];
%=============================================================================
R = [A, B];
REF = [ "a",    "d";
"2",    "e";
"c",    "f"];
assert_isequal(R, REF);
%=============================================================================
R = [B, A];
REF = ["d",    "a";
"e",    "2";
"f",    "c"];
assert_isequal(R, REF);
%=============================================================================
R = [1; "A"];
REF = ["1"; "A"];
assert_isequal(R, REF);
%=============================================================================
R = ["A"; 1];
REF = ["A"; "1"];
assert_isequal(R, REF);
%=============================================================================
R = [100; 'A'];
REF = ['d';'A'];
assert_isequal(R, REF);
%=============================================================================
R = ['A'; 100];
REF = ['A';'d'];
assert_isequal(R, REF);
%=============================================================================
